AJS.toInit(function()
{
    var sharePointSearchURL = (AJS.params.contextPath || "") + "/plugins/servlet/sharepoint/search";
    var confluenceSearchURL = (AJS.params.contextPath || "") + "/dosearchsite.action";
    var originalSearchBox;
    var sharePointSearchBox;

    // Locate the Confluence quick search form.
    var quickSearch = AJS.$("#quick-search");
    if (quickSearch == null || quickSearch == undefined)
    {
        alert("The current theme has no quick search. SharePoint searching cannot be enabled.");
        return;
    }

    // Hijack the quick search form and modify it to suit our nefarious purposes...
    // TODO: Note, this totally neuters the awesome quick search auto-complete that you get with Confluence search. We should try to preserve it.
    // clone and replace the quick search query box with a similar box. This will unwire the events for the quicksearch, which won't work with SharePoint search.
    originalSearchBox = quickSearch.find("#quick-search-query");
    sharePointSearchBox = originalSearchBox.clone();
    sharePointSearchBox.attr("title", "");
    sharePointSearchBox.attr("value", "Search");
    sharePointSearchBox.attr("id", "sharepoint-search-query"); // change the ID of the field; this should stop any other Confluence JS from hacking on it.

    // Re-implement the hint text on focus/blur
    sharePointSearchBox.focus(function()
    {
        var target = AJS.$("#sharepoint-search-query");
        target.removeClass("placeholded");
        target.attr("value", "");
    });
    sharePointSearchBox.blur(function()
    {
        var target = AJS.$("#sharepoint-search-query");
        target.addClass("placeholded");
        target.attr("value", "Search");
    });

    var selectBox = AJS.$("<select id=\"quick-search-sharepoint-option\"> <option id=\"quick-search-sharepoint\">SharePoint & Confluence</option><option id=\"quick-search-confluence\">Confluence Only</option></select>");
    AJS.log("Cookie saved?: " + AJS.Cookie.read("SHAREPOINT_SEARCH_SELECTED"));
    var sharePointSearchSelected = AJS.Cookie.read("SHAREPOINT_SEARCH_SELECTED");
    AJS.log(sharePointSearchSelected);
    if (sharePointSearchSelected == undefined || sharePointSearchSelected == "sharepoint")
    {
        quickSearch.attr("action", sharePointSearchURL);
        originalSearchBox.before(sharePointSearchBox);
        sharePointSearchBox.before(selectBox);
        AJS.$("#quick-search-sharepoint", selectBox).attr("selected", "true");

        // move the original search box out of the <form> so that its value doesn't get submitted.
        quickSearch.after(originalSearchBox);
        originalSearchBox.hide();
    }
    else
    {
        originalSearchBox.before(selectBox);
        AJS.$("#quick-search-confluence", selectBox).attr("selected", "true");
    }

    selectBox.change(function()
    {
        // which one is selected?
        var sharePointOption = AJS.$("#quick-search-sharepoint", selectBox);
        if (sharePointOption.attr("selected"))
        {
            AJS.log("setting options for SharePoint search.");
            // set options for SharePoint search.
            quickSearch.attr("action", sharePointSearchURL);

            // move it out of the form so it doesn't submit anything.
            quickSearch.after(originalSearchBox);
            selectBox.after(sharePointSearchBox);

            originalSearchBox.hide();
            sharePointSearchBox.show();
            AJS.Cookie.save("SHAREPOINT_SEARCH_SELECTED", "sharepoint");
            AJS.log("Cookie saved?: " + AJS.Cookie.read("SHAREPOINT_SEARCH_SELECTED"));
        }
        else
        {
            // set options for Confluence-only search.
            AJS.log("setting options for Confluence search.");
            quickSearch.attr("action", confluenceSearchURL);

            quickSearch.after(sharePointSearchBox);
            selectBox.after(originalSearchBox);

            sharePointSearchBox.hide();
            originalSearchBox.show();
            AJS.Cookie.save("SHAREPOINT_SEARCH_SELECTED", "confluence");
            AJS.log("Cookie saved?: " + AJS.Cookie.read("SHAREPOINT_SEARCH_SELECTED"));
        }
    });

    quickSearch.find("#quickNavEnabled").attr("value", "false");
    quickSearch.find("#quickSearchPlaceholder").attr("value", "Search");
});


